<template>
  <v-data-table
    :headers="headers"
    :items="messages"
    :items-per-page="50"
    :loading="loading"
    class="elevation-1"
  >
    <template v-slot:item.severity="{ item }">
      <v-icon large :color="getIconColor(item.severity)">{{ getIconName(item.severity) }}</v-icon>
    </template>
  </v-data-table>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"
import { Message, Severity } from "@/model"
import { getMessages, isLoading } from "@/store"

@Component
export default class MessagesTable extends Vue {
  get messages(): Array<Message> {
    return getMessages()
  }

  get loading(): boolean {
    return isLoading()
  }

  headers = [
    {
      value: "severity",
      sort: (severity1: Severity, severity2: Severity) => {
        let severityOrder: { [key in Severity]: number } = {
          [Severity.Error]: 3,
          [Severity.Critical]: 2,
          [Severity.Warning]: 1,
          [Severity.OK]: 0,
        }

        if (severityOrder[severity1] > severityOrder[severity2]) return 1
        if (severityOrder[severity1] < severityOrder[severity2]) return -1
        return 0
      }
    },
    {
      text: "Message",
      value: "subject"
    },
    {
      text: "Details",
      value: "details"
    },
    {
      text: "Source",
      value: "source.name"
    },
  ]

  getIconColor(severity: string): string {
    if (severity === Severity.Error) return 'red darken-2'
    else if (severity === Severity.Critical) return 'orange darken-2'
    else if (severity === Severity.Warning) return 'yellow darken-2'
    else return 'green darken-2'
  }

  getIconName(severity: string): string {
    if (severity === Severity.Error) return 'mdi-alert'
    else if (severity === Severity.Critical) return 'mdi-information'
    else if (severity === Severity.Warning) return 'mdi-information'
    else return 'mdi-check'
  }
}
</script>